%Optimierung im Zeitbereich, Minimum-Berechnung
%Zeitgewichtete Betragsregelflche ITAE
%optimierung_ITAE_step.m
%Eingangsgre Sprungfunktion

clear, clc, format long

delta_t = 0.0001; tmax = 150.0; nn = round (tmax / delta_t);
x = zeros (nn+1,1); t = zeros (nn+1,1); t = 0:delta_t:tmax;
w = ones(nn+1,1); nmax = 8; dfa = 1.0e-5; df_min = 0.75e-5; 

berechne = 1; n = 2; %Ergebnisse
A_ITAE =  1.951859474916330; ue = 0.027629054535782; tanr = 3.6781;
f1m = 1.50487984375;
%Minimum-Berechnung
A_min = inf; df =  dfa;
while df > df_min / 50.0 && berechne == 1
    anz_min = 1; j = 0; 
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df   
    G_ITAE_s(n) = tf(1.0, [1 f1 1]);
    x = step(G_ITAE_s(n), t);
    A = delta_t * trapz(t' .* abs(w - x));    
    if A_min > A + eps
       A_min = A; ue = max(x) - 1.0;
       f1_min = f1; anz_min = anz_min + 1;
       k = 1;
       while x(k) < 1.0
          k = k + 1;
       end
       tanr = t(k);
    end
end
j = j + 1, df, anz_min, A_ITAE = A_min, ue, tanr, f1m = f1_min
end
df = df / 2.0;
end
G_ITAE_s(n) = tf(1.0, [1 f1m 1]);
n, nullstellen = roots(G_ITAE_s(n).den{1})

berechne = 0; n = 3; %Ergebnisse
A_ITAE =  3.138258642372147; ue = 0.015706252695714; tanr = 4.1460;
f1m = 2.17148; f2m = 1.78277;
%Minimum-Berechnung
A_min = inf; df =  dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df 
    for f2 = f2m-df:df:f2m+df 
        G_ITAE_s(n) = tf(1.0, [1 f2 f1 1]);
        x = step(G_ITAE_s(n), t);
        A = delta_t * trapz(t' .* abs(w - x));
        if A_min > A + eps
           A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1;
           f1_min = f1; f2_min = f2;
           k = 1;
           while x(k) < 1.0
              k = k + 1;
           end
           tanr = t(k);
        end
    end
end
j = j + 1, df, anz_min
A_ITAE = A_min, ue, tanr, f1m = f1_min, f2m = f2_min
end
df = df / 2.0;
end
G_ITAE_s(n) = tf(1.0, [1 f2m f1m 1]);
n, nullstellen = roots(G_ITAE_s(n).den{1})

berechne = 0; n = 4; %Ergebnisse
A_ITAE = 4.591274872572031; ue = 0.018460663751421; tanr = 4.6661;
f1m = 2.64731; f2m = 3.34577; f3m = 1.95205;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df 
    for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df 
            G_ITAE_s(n) = tf(1.0, [1 f3 f2 f1 1]);
            x = step(G_ITAE_s(n), t);
            A = delta_t * trapz(t' .* abs(w - x));
            if A_min > A + eps
               A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1; 
               f1_min = f1; f2_min = f2; f3_min = f3;
               k = 1;
               while x(k) < 1.0
                  k = k + 1;
               end
               tanr = t(k);
            end
         end
    end
end
j = j + 1, df, anz_min, 
A_ITAE = A_min, ue, tanr, f1m = f1_min, f2m = f2_min, f3m = f3_min 
end
df = df / 2.0;
end
G_ITAE_s(n) = tf(1.0, [1 f3m f2m f1m 1]);
n, nullstellen = roots(G_ITAE_s(n).den{1})

berechne = 0; n = 5; %Ergebnisse
A_ITAE = 6.321555390740295; ue = 0.017212887253645; tanr = 5.2051;
f1m =  3.25683; f2m = 4.67312; f3m = 4.49761; f4m = 2.06681;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df
        for f3 = f3m-df:df:f3m+df
            for f4 = f4m-df:df:f4m+df           
               G_ITAE_s(n) = tf(1.0, [1 f4 f3 f2 f1 1]);
               x = step(G_ITAE_s(n), t);
               A = delta_t * trapz(t' .* abs(w - x));
               if A_min > A
                  A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1;
                  f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                  k = 1;
                  while x(k) < 1.0
                     k = k + 1;
                  end
                  tanr = t(k);
               end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ITAE = A_min, ue, tanr,
f1m = f1_min, f2m = f2_min, f3m = f3_min, f4m = f4_min
end
df = df / 2.0;
end
G_ITAE_s(n) = tf(1.0, [1 f4m f3m f2m f1m 1]);
n, nullstellen = roots(G_ITAE_s(n).den{1})

berechne = 0; n = 6; %Ergebnisse
A_ITAE =  8.333970588687704; ue = 0.019297332196547; tanr = 5.7505;
f1m = 3.73991; f2m = 6.79289; f3m = 6.93463;
f4m = 5.62938; f5m = 2.15234;
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    for f2 = f2m-df:df:f2m+df
        for f3 = f3m-df:df:f3m+df
            for f4 = f4m-df:df:f4m+df           
                for f5 = f5m-df:df:f5m+df
                    G_ITAE_s(n) = tf(1.0, [1 f5 f4 f3 f2 f1 1]);
                    x = step(G_ITAE_s(n), t);
                    A = delta_t * trapz(t' .* abs(w - x));
                    if A_min > A + eps
                    A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1; 
                    f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                    f5_min = f5;
                    k = 1;
                    while x(k) < 1.0
                       k = k + 1;
                    end
                    tanr = t(k);
                    end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ITAE = A_min, ue, tanr,
f1m = f1_min, f2m = f2_min, f3m = f3_min, f4m = f4_min, f5m = f5_min 
end
df = df / 2.0;
end
G_ITAE_s(n) = tf(1.0, [1 f5m f4m f3m f2m f1m 1]);
n, nullstellen = roots(G_ITAE_s(n).den{1})

berechne = 0; n = 7; %Ergebnisse
A_ITAE = 10.630574578240006; ue = 0.021718106256279; tanr = 6.2973;
f1m =  4.32330; f2m = 8.68162; f3m = 11.58190;
f4m =  9.35554; f5m = 6.74637; f6m =  2.22004;  
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    f1
    for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df 
            for f4 = f4m-df:df:f4m+df            
                for f5 = f5m-df:df:f5m+df 
                    for f6 = f6m-df:df:f6m+df
                    G_ITAE_s(n) = tf(1.0, [1 f6 f5 f4 f3 f2 f1 1]);
                    x = step(G_ITAE_s(n), t);
                    A = delta_t * trapz(t' .* abs(w - x));
                    if A_min > A + eps
                    A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1; 
                    f1_min = f1; f2_min = f2; f3_min = f3;
                    f4_min = f4; f5_min = f5; f6_min = f6;
                    k = 1;
                    while x(k) < 1.0
                       k = k + 1;
                    end
                    tanr = t(k);
                    end
                    end
                end
            end
        end

    end
end
j = j + 1, df, anz_min, A_ITAE = A_min, ue, tanr,
f1m = f1_min, f2m = f2_min, f3m = f3_min
f4m = f4_min, f5m = f5_min, f6m = f6_min 
end
df = df / 2.0;
end
G_ITAE_s(n) = tf(1.0, [1 f6m f5m f4m f3m f2m f1m 1]);
n, nullstellen = roots(G_ITAE_s(n).den{1})

berechne = 0; n = 8; %Ergebnisse
A_ITAE = 13.211360750567296; ue = 0.024301382527573; tanr =  6.8431;
f1m =  4.81462; f2m = 11.33956; f3m = 16.11424;
f4m = 17.59307; f5m = 11.88807; f6m = 7.85213; f7m =  2.27496;   
%Minimum-Berechnung
A_min = inf; df = dfa;
while df > df_min && berechne == 1
    anz_min = 1; j = 0;
while anz_min > 0 
    anz_min = 0;
for f1 = f1m-df:df:f1m+df
    f1
    for f2 = f2m-df:df:f2m+df 
        for f3 = f3m-df:df:f3m+df 
            for f4 = f4m-df:df:f4m+df            
                for f5 = f5m-df:df:f5m+df 
                    for f6 = f6m-df:df:f6m+df
                    for f7 = f7m-df:df:f7m+df
                    G_ITAE_s(n) = tf(1.0, [1 f7 f6 f5 f4 f3 f2 f1 1]);
                    x = step(G_ITAE_s(n), t);
                    A = delta_t * trapz(t' .* abs(w - x));
                    if A_min > A + eps
                    A_min = A; ue = max(x) - 1.0; anz_min = anz_min + 1; 
                    f1_min = f1; f2_min = f2; f3_min = f3; f4_min = f4;
                    f5_min = f5; f6_min = f6; f7_min = f7;
                    k = 1;
                    while x(k) < 1.0
                    k = k + 1;
                    end
                    tanr = t(k);
                    end
                    end
                    end
                end
            end
        end
    end
end
j = j + 1, df, anz_min, A_ITAE = A_min, ue, tanr,
f1m = f1_min, f2m = f2_min, f3m = f3_min
f4m = f4_min, f5m = f5_min, f6m = f6_min, f7m = f7_min 
end
df = df / 2.0;
end
G_ITAE_s(n) = tf(1.0, [1 f7m f6m f5m f4m f3m f2m f1m 1]);
n, nullstellen = roots(G_ITAE_s(n).den{1})

t = 0:10.0*delta_t:8; w = ones(length(t'), 1);
figure (1)
for n = 2:nmax
        x = step(G_ITAE_s(n), t);
        plot(t, x), hold on, grid on
end
plot(t', w, 'k')
title('Optimierung im Zeitbereich, ITAE-Kriterium')
xlabel('Zeit t / s'), ylabel('Sprungantwort x(t)')

figure (2)
for n = 2:nmax
        x = step(G_ITAE_s(n), t);
        plot(t, w - x), hold on, grid on
end
title('Optimierung im Zeitbereich, ITAE-Kriterium')
xlabel('Zeit t / s'), ylabel('Regeldifferenz x_d(t) = w(t) - x(t)')

%{
n =   2 nullstellen =
  -0.7524 + 0.6587i  -0.7524 - 0.6587i

n =   3 nullstellen =
  -0.5368 + 1.0592i  -0.5368 - 1.0592i
  -0.7092          

n =   4 nullstellen =
  -0.3892 + 1.3254i  -0.3892 - 1.3254i
  -0.5868 + 0.4240i  -0.5868 - 0.4240i

n =   5 nullstellen =
  -0.2897 + 1.5086i  -0.2897 - 1.5086i
  -0.4637 + 0.7360i  -0.4637 - 0.7360i
  -0.5600          

n =   6 nullstellen =
  -0.2204 + 1.6397i  -0.2204 - 1.6397i
  -0.3663 + 0.9742i  -0.3663 - 0.9742i
  -0.4895 + 0.3125i  -0.4895 - 0.3125i

n =   7 nullstellen =
  -0.1708 + 1.7375i  -0.1708 - 1.7375i
  -0.2924 + 1.1575i  -0.2924 - 1.1575i
  -0.4104 + 0.5642i  -0.4104 - 0.5642i
  -0.4729          

n =   8 nullstellen =
  -0.1343 + 1.8130i  -0.1343 - 1.8130i
  -0.2357 + 1.3011i  -0.2357 - 1.3011i
  -0.3410 + 0.7712i  -0.3410 - 0.7712i
  -0.4265 + 0.2480i  -0.4265 - 0.2480i
%}

