%MATLAB Script-File ortsk2_166.m
%Ortskurve eines offenen Regelkreises
KS=1; DS=0.5; w0s=1;      	%Parameter der Regelstrecke
T1=1;
a3=1; a2=1+2*DS*w0s*T1;  	%Koeffizienten des
a1=2*DS*w0s+w0s*w0s*T1;   	%Nennerpolynoms
a0=w0s^2;                 	%von GRS(s)
denGRS=[a3 a2 a1 a0];    	%Nennerpolynom von GRS(s)
w=logspace(-2,1,150);     	%logarithmische Teilung fr w
clf
hold on
axis('equal')				%gleicher Skalierungsfaktor
text(0.8,0.1,'\it{1}'), 	%Text einfgen
text(1.8,0.1,'\it{2}'), 
text(2.2,0.1,'{\itK}_{RS}{\it=3}')

for KR=1:3
   numGRS=[0 0 0 KR*KS];  	%Zhlerpolynom und
   denG=denGRS+numGRS;    	%Nennerpolynom von G(s)
   GRS=tf(numGRS,denGRS);	%GRS(s)
   spi=roots(denG)        	%Pole von G(s)         
   nyquist(GRS,w);			%Ortskurve
end 
                          	%Titel der Grafik:
title('{\itOrtskurven fr F}_{RS}{\it(j\omega)}')







