%MATLAB Script-File tf_bode2_166.m
%Amplituden- und Phasenreserve eines offenen Regelkreises
clf								 %Grafisches Fenster lschen
KS=2; T1=1; T2=0.1; T3=T2; KR=5; %Parameter
numGRS=KR*KS;                    %Zhlerpolynom von GRS(s)
nen=conv([T1 1],[T2 1]);         %Nennerpolynom Teilstrecke
denGRS=conv(nen,[T3 1]);         %Nennerpolnom von GRS(s)
GRS=tf(numGRS,denGRS);			 %GRS(s)
w=logspace(-1, 3, 100);          %Spaltenvektor der w-Werte

[betrag,phase,w]=bode(GRS,w);    %Betrag und Phase
[Gm,Pm,wpi,wD]=margin(betrag,phase,w);    %Amplituden- und Phasenreserve
fprintf('Phasenreserve Pm =%8.3f Grad \n',Pm)
fprintf('Durchtrittskreisfrequenz wD =%8.3f/s \n',wD)

fprintf('Amplitudenreserve Gm =%8.3f \n',Gm)
fprintf('Phasenschnittkreisfrequenz wpi =%8.3f/s \n',wpi)

%Amplitudengang (logarithmierter Betrag) zeichnen:
subplot(311), semilogx(w,log10(betrag(:)));
title('\it{Amplitudengang}')            %Titel der Grafik
ylabel('{\itlg|F}_{RS}{\it(j\omega)|}') %Beschriftung der Ordinate
grid                                    %kartesische Gitterlinien

%Amplitudengang (logarithmierter Betrag in dB) zeichnen:
subplot(312), semilogx(w,20*log10(betrag(:)));
title('\it{Amplitudengang in dB}')      
ylabel('{\it20*lg|F}_{RS}{\it(j\omega)|}')
grid

%Phasengang:
subplot(313), semilogx(w,phase(:));     %Phase in Grad
title('\it{Phasengang}')
ylabel('\it{Grad}')
grid
